
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "CPU.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::matahari;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  CPU::packageName  = string ("com.redhat.matahari");
string  CPU::className    = string ("cpu");
uint8_t CPU::md5Sum[MD5_LEN]   =
    {0x92,0x6f,0xb5,0xe0,0xea,0x17,0x6a,0xa9,0xa7,0x3e,0xf2,0x61,0x19,0x63,0x8b,0x3e};

CPU::CPU (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent) :
    ManagementObject(_core)
{
    host = _parent->GetManagementObject ()->getObjectId ();
    cpunum = 0;
    corenum = 0;
    numcores = 0;
    model = 0;
    family = 0;
    cpuid_lvl = 0;
    speed = 0.;
    cache = 0;
    vendor = "";
    flags = "";



}

CPU::~CPU ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void CPU::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void CPU::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (11); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "host";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host that this cpu belongs to";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpunum";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "CPU # for this host";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "corenum";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Index of core within CPU";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "numcores";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Total # of cores for CPU";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "model";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Processor Model";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "family";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Processor Family";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cpuid_lvl";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "CPU ID Level";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "speed";
    ft[TYPE] = TYPE_DOUBLE;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "MHz";
    ft[DESC] = "CPU Speed";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "cache";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "kb";
    ft[DESC] = "CPU Cache Size";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "vendor";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "CPU Vendor";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "flags";
    ft[TYPE] = TYPE_LSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "CPU Flags";
    buf.putMap(ft);


    // Statistics

    // Methods

    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string CPU::getKey() const
{
    std::stringstream key;

    key << host.getV2Key() << ",";
    key << cpunum;
    return key.str();
}



void CPU::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["host"] = ::qpid::types::Variant(host);
    _map["cpunum"] = ::qpid::types::Variant(cpunum);
    _map["corenum"] = ::qpid::types::Variant(corenum);
    _map["numcores"] = ::qpid::types::Variant(numcores);
    _map["model"] = ::qpid::types::Variant(model);
    _map["family"] = ::qpid::types::Variant(family);
    _map["cpuid_lvl"] = ::qpid::types::Variant(cpuid_lvl);
    _map["speed"] = ::qpid::types::Variant(speed);
    _map["cache"] = ::qpid::types::Variant(cache);
    _map["vendor"] = ::qpid::types::Variant(vendor);
    _map["flags"] = ::qpid::types::Variant(flags);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void CPU::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("host")) != _map.end()) {
        host = _i->second;
    }
    if ((_i = _map.find("cpunum")) != _map.end()) {
        cpunum = _i->second;
    }
    if ((_i = _map.find("corenum")) != _map.end()) {
        corenum = _i->second;
    }
    if ((_i = _map.find("numcores")) != _map.end()) {
        numcores = _i->second;
    }
    if ((_i = _map.find("model")) != _map.end()) {
        model = _i->second;
    }
    if ((_i = _map.find("family")) != _map.end()) {
        family = _i->second;
    }
    if ((_i = _map.find("cpuid_lvl")) != _map.end()) {
        cpuid_lvl = _i->second;
    }
    if ((_i = _map.find("speed")) != _map.end()) {
        speed = _i->second;
    }
    if ((_i = _map.find("cache")) != _map.end()) {
        cache = _i->second;
    }
    if ((_i = _map.find("vendor")) != _map.end()) {
        vendor = (_i->second).getString();
    }
    if ((_i = _map.find("flags")) != _map.end()) {
        flags = (_i->second).getString();
    }

}

void CPU::doMethod (string&, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
