
#ifndef _MANAGEMENT_HOST_
#define _MANAGEMENT_HOST_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace matahari {


class Host : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    std::string uuid;
    std::string hostname;
    int32_t memory;
    std::string hypervisor;
    std::string arch;
    bool beeping;

    // Statistics


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }


    Host(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Host();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_SHUTDOWN = 1;
    static const uint32_t METHOD_REBOOT = 2;

    // Accessor Methods
    inline void set_uuid (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        uuid = val;
        configChanged = true;
    }
    inline const std::string& get_uuid() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return uuid;
    }
    inline void set_hostname (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        hostname = val;
        configChanged = true;
    }
    inline const std::string& get_hostname() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return hostname;
    }
    inline void set_memory (int32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        memory = val;
        configChanged = true;
    }
    inline int32_t get_memory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return memory;
    }
    inline void set_hypervisor (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        hypervisor = val;
        configChanged = true;
    }
    inline const std::string& get_hypervisor() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return hypervisor;
    }
    inline void set_arch (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        arch = val;
        configChanged = true;
    }
    inline const std::string& get_arch() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return arch;
    }
    inline void set_beeping (bool val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        beeping = val;
        configChanged = true;
    }
    inline bool get_beeping() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return beeping;
    }

};

}}}}

#endif  /*!_MANAGEMENT_HOST_*/
